program get_fx_sample;
uses intserial,crt;

{$i hex}

const
     stx=#2;
     etx=#3;
     enq=#5;
     ack=#6;
     ss=#$1a;

var
   i : longint;
   j,v : integer;
   ch : char;
   data : array[0..32167] of byte;
   data_len : integer;
   block : string;
   filename : string;
   comport : integer;

(***********************************************************************)
procedure req_block(address,len : longint);
var
   i : integer;
   chksum : integer;
   s : string;

begin
     s:=stx+'E';
     s:=s+hex2(address div 65536)+hex4(address mod 65536)+hex2(len)+etx;
     chksum:=-2;
     for i:=1 to length(s) do
         chksum:=chksum+ord(s[i]);
     s:=s+hex2(chksum mod 256);
     gotoxy(1,8);
     Writeln(' Requesting address ',hex2(address div 65536),hex4(address mod 65536));
     clreol;
     sWrite(s);
end;
(***********************************************************************)

procedure check_block(sblock,chkstr : string);
var
   i,j,v : integer;
   c : integer;
begin
     c:=0;
     for i:=2 to length(sblock) do
     begin
          c:=c+ord(sblock[i]);
     end;
     c:=c mod 256;
     val('$'+chkstr,v,j);
     if c<>v then
     begin
          errflg:=true;
          Writeln('Block total = ',c:4,' Check sum = ',v);
     end;

end;

(***********************************************************************)

procedure get_block(var block : string);

var
   ch : char;
   s : string;
   chkstr : string;

begin
     s:='';
     repeat
     begin
           ch:=sreadkey;
           s:=s+ch;
     end;
     until (ch=etx) or (errflg);
     if errflg then exit;
      {checksum}
     chkstr:=sreadkey;
     if errflg then exit;
     chkstr:=chkstr+sreadkey;
     if errflg then exit;
     check_block(s,chkstr);
     if errflg then exit;
     block:=s;
end;
(***********************************************************************)

procedure save_block(block : string);
var
   i,v : integer;
   b : byte;
begin
     for i:=1 to length(block) div 2 -1 do
     begin
          val('$'+copy(block,i*2,2),b,v);
          data[data_len]:=b;
          inc(data_len);
     end;
end;
(***********************************************************************)

procedure write_data;
var
   i : integer;
   outfile : file of byte;
   b : byte;
begin
     b:=0;
     Writeln(' Saving data to ',filename);
     assign(outfile,filename);
     rewrite(outfile);
     for i:=0 to 255 do
         Write(outfile,b);
     for i:=0 to data_len-1 do
         Write(outfile,data[i]);
     close(outfile);
end;
(***********************************************************************)
procedure clear;
begin
     clrscr;
     Writeln(' ++++++     FXDUE Sample Data Reader    ++++++');
     Writeln(' ++++++     (c) C.W.Parish Ltd 1994     ++++++');
     Writeln(' ++++++       (c) A.Russell 1994        ++++++');
     Writeln;
end;

(***********************************************************************)

begin
     clear;
     data_len:=0;
     comport:=2;
     if paramcount>0 then
        filename:=paramstr(1)
     else
         begin
              Write(' Output File Name :- ');
              readln(filename);
         end;
     if paramcount>1 then
     begin
          val(paramstr(2),v,j);
          if i=0 then comport:=v
             else
                 comport:=2;
     end;
     filename:=filename+'.SDT';
     Writeln(' Using ',filename,' on COM',comport);
     init_comm(comport,9600,'E',7,1);
     Writeln(' Sending ENQ');
     sWrite(enq);
     Writeln(' Waiting for ACK');
     i:=0;
     repeat
           ch:=sreadkey;
     until (errflg) or (ch=ack);
     if ch<>ack then Writeln(' No Acknowledgement ');
     if timeout then
     begin
          Writeln(' Unable to locate FXDUE on COM',comport,' Check connections and port number.');
          halt(0);
     end;
     clear;
     Writeln(' Using ',filename,' on COM',comport);
     for i:=1024 to 1024+124 do
     begin
          repeat
          begin
               errflg:=false;
               req_block(64*i,64);
               if timeout then
               begin
                    Writeln(' Unable to locate FXDUE on COM',comport,' Check connections and port number.');
                    halt(0);
               end;
               get_block(block);
               if timeout then
               begin
                    Writeln(' Unable to locate FXDUE on COM',comport,' Check connections and port number.');
                    halt(0);
               end;
          end;
          until not(errflg);
          save_block(block);
     end;
     swrite(ss);
     Write_data;
end.
