unit intserial;
{ Comms comm (UART) driver routines by A.Russell 1991 }
{ And they do work !!!! }
interface
uses dos;

(***********************************************************************)
procedure init_comm( acomm : word; abaud_rate : word; aparity : char;
                     abits,astop : word);
{ Eg. 2,9600,N,7,1 }

function sreadkey : char;

procedure sreadln( var instring : string);

procedure swrite(out_string : string);

procedure swriteln(out_string : string);

procedure putchar( ch : char);

{ These will not get used much }
function get_line_status : byte; { line status }
function get_modem_status : byte; { modem status }


(***********************************************************************)
var
   echo : boolean;
   errflg,timeout : boolean;
(***********************************************************************)
(***********************************************************************)

implementation
{$i hex}

const
     timeout_value=15000;

VAR
   comm : word;
   baud_rate : word;
   parity : char;
   bits,stop : word;
(************************************************************************)

procedure init;
{ Eg. 2,9600,N,7,1 }
var
   b : byte;
   t : byte;
   regs : registers;
begin
     case baud_rate of
          110 : b:=0;
          150 : b:=1;
          300 : b:=2;
          600 : b:=3;
          1200 : b:=4;
          2400 : b:=5;
          4800 : b:=6;
          9600 : b:=7;
     else b:=7;
     end;
     t:=b*32;
     case parity of
          'N','n' : b:=0;
          'O','o' : b:=1;
          'E','e' : b:=3;
     else b:=0;
     end;
     t:=t+b*8;
     case stop of
          1 : t:=t+0;
          2 : t:=t+4;
     end;
     case bits of
          7 : t:=t+2;
          8 : t:=t+3;
          else t:=t+3;
     end;
     regs.ah:=0;
     regs.al:=t;
     regs.dx:=comm;
     intr($14,regs);
end;

procedure init_comm( acomm : word; abaud_rate : word; aparity : char;
                     abits,astop : word);
{ Eg. 2,9600,N,7,1 }
begin
     comm:=acomm-1;
     baud_rate:=abaud_rate;
     parity:=aparity;
     bits:=abits;
     stop:=astop;
     init;
end;
(************************************************************************)
(************************************************************************)
function get_line_status : byte;
var
   regs : registers;
begin
     regs.ah:=3;
     regs.dx:=comm;
     intr($14,regs);
     get_line_status:=regs.ah;

end;
(************************************************************************)
function get_modem_status : byte;
var
   regs : registers;
begin
     regs.ah:=3;
     regs.dx:=comm;
     intr($14,regs);
     get_modem_status:=regs.al;
end;
(************************************************************************)
procedure putchar( ch : char);
var
   regs : registers;
   i : integer;
begin
     i:=0;
     timeout:=false;
     repeat
     begin
          inc(i);
          regs.ah:=3;
          regs.dx:=comm;
          intr($14,regs);
     end;
     until ((regs.ah and $20)=$20) or (i>timeout_value);
     if i>timeout_value then
     begin
          timeout:=true;
          errflg:=true;
          exit;
     end;
     regs.ah:=1;
     regs.al:=ord(ch);
     regs.dx:=comm;
     intr($14,regs);
end;

function sreadkey : char;
var
   ch : byte;
   regs : registers;
   i : integer;

begin
     i:=0;
     timeout:=false;
     repeat
     begin
          inc(i);
          regs.ah:=3;
          regs.dx:=comm;
          intr($14,regs);
     end;
     until odd(regs.ah) or (i>timeout_value);
     if i>timeout_value then
     begin
          timeout:=true;
          errflg:=true;
          exit;
     end;
     if (regs.ah and $8e)>0 then
     begin
          Writeln(' Recieve error. Status = ',hex2(regs.ah));
          init;
          errflg:=true;
     end;

     regs.ah:=2;
     regs.dx:=comm;
     intr($14,regs);
     ch:=regs.al;
     sreadkey:=chr(ch);
end;


procedure sreadln( var instring : string);
var
   ch : char;
begin
     instring:='';
     ch:=sreadkey;
     while ch<>chr(13) do
     begin
          if (ord(ch)=8) and (length(instring)>0) then
          begin
             instring:=copy(instring,1,length(instring)-1);
             putchar(' ');
             putchar(chr(8));
          end
          else
              instring:=instring+ch;
          ch:=sreadkey;
     end;
end;

procedure swrite(out_string : string);
var
   i : integer;
begin
     for i:=1 to length(out_string) do
     begin
          putchar(out_string[i]);
          if errflg then exit;
     end;
end;


procedure swriteln(out_string : string);
var
   i : integer;
begin
     swrite(out_string);
     putchar(chr(13));
     putchar(chr(10));
end;
(************************************************************************)
begin
     comm:=1;
     baud_rate:=9600;
     parity:='N';
     bits:=8;
     stop:=1;
end
.
