program put_fx_dat;
uses intserial,crt;

{$i hex}

const
     stx=#2;
     etx=#3;
     enq=#5;
     ack=#6;
     ss=#$1a;

var
   i,v : integer;
   ch : char;
   data : array[0..32167] of byte;
   data_count : integer;
   block : string;
   filename : string;
   comport : integer;

(***********************************************************************)
procedure put_block(address,len : longint);
var
   i : integer;
   chksum : integer;
   s : string;
   start : longint;

begin
     s:=stx+'F';
     s:=s+hex2(address div 65536)+hex4(address mod 65536)+hex2(len);
     start:=address-$1100;
     for i:=start to (start+len)-1 do
     begin
          s:=s+hex2(data[i]);
     end;
     s:=s+etx;
     chksum:=-2;
     for i:=1 to length(s) do
         chksum:=chksum+ord(s[i]);
     s:=s+hex2(chksum mod 256);

     gotoxy(1,8);

     Writeln(' Sending address ',hex4(address));
     clreol;
     for i:=1 to length(s) do
         putchar(s[i]);
     delay(1500);
end;
(***********************************************************************)

procedure Read_data;
var
   i : integer;
   infile : file of byte;
begin
     Writeln(' Loading data from ',filename);
     assign(infile,filename);
     reset(infile);
     if filesize(infile)<>4000 then
     begin
          Writeln(' This file is not a FXDUE data file.');
          close(infile);
          halt(0);
     end;
     reset(infile);
     for i:=0 to 3999 do
         read(infile,data[i]);
     close(infile);
     data_count:=0;
end;
(***********************************************************************)
procedure clear;
begin
     clrscr;
     Writeln(' ++++++    FXDUE Data File Writer     ++++++');
     Writeln(' ++++++    (c) C.W.Parish Ltd 1994    ++++++');
     Writeln(' ++++++     (c) A.Russell 1994        ++++++');
     Writeln;
end;

(***********************************************************************)

begin
     for i:=0 to 3999 do
         data[i]:=0;

     clear;
     comport:=2;
     if paramcount>0 then
        filename:=paramstr(1)
     else
         begin
              Write(' Source File Name For Data :- ');
              readln(filename);
         end;
     if paramcount>1 then
     begin
          val(paramstr(2),v,i);
          if i=0 then comport:=v
             else
                 comport:=2;
     end;
     read_data;
     Writeln(' Using ',filename,' on COM',comport);
     init_comm(comport,9600,'E',7,1);
     Writeln(' Sending ENQ');
     sWrite(enq);
     Writeln(' Waiting for ACK');
     i:=0;
     repeat
           ch:=sreadkey;
     until (errflg) or (ch=ack);
     if ch<>ack then Writeln(' No Acknowledgement ');
     if timeout then
     begin
          Writeln(' Unable to locate FXDUE on COM',comport,' Check connections and port number.');
          halt(0);
     end;
     clear;
     Writeln(' Using ',filename,' on COM',comport);
     ch:=sreadkey;
     for i:=68 to 129 do
     begin
          repeat
          begin
               errflg:=false;
               put_block(64*i,64);
               if timeout then
               begin
                    Writeln(' Unable to locate FXDUE on COM',comport,' Check connections and port number.');
                    halt(0);
               end;
               ch:=sreadkey;
               Write(ch);
               if ch<>ack then
               begin
                    Writeln(' Block not acknowledged ');
                    errflg:=true;
               end;
               if timeout then
               begin
                    Writeln(' Unable to locate FXDUE on COM',comport,' Check connections and port number.');
                    halt(0);
               end;
          end;
          until not(errflg);
     end;
{ tidy up the last block }
     repeat
          begin
               errflg:=false;
               put_block(64*130,32);
               if timeout then
               begin
                    Writeln(' Unable to locate FXDUE on COM',comport,' Check connections and port number.');
                    halt(0);
               end;
               ch:=sreadkey;
               if ch<>ack then
               begin
                    Writeln(' Block not acknowledged ');
                    errflg:=true;
               end;
               if timeout then
               begin
                    Writeln(' Unable to locate FXDUE on COM',comport,' Check connections and port number.');
                    halt(0);
               end;
          end;
          until not(errflg);
end.
